
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>（一四七）私有继承 / iVAN</title>

    <meta name="description" content="（一四七）私有继承 C++的另一种实现has-a关系的途径(前一种是将类对象作为新类的成员)是私有继承.   使用私有继承,基类的公有成员和保护成员都将成为派生类的私有成员. 这意味着基类方法将不会成为派生类对象公有接口的一部分(公有继承,派生类可以使用基类的大部分方法),但可以在派生类的成员函数中使用它们.     私有继承的特点: ①继承方式类似公有继承,但使用private关键字替代public关键字:   ②没有显式的对象名:   ③需要使用其他办法替代 当使用类对象作为类数据成员时使用的方法.   ④基类">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">（一四七）私有继承</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>C++的另一种实现has-a关系的途径（前一种是将类对象作为新类的成员）是<strong>私有继承</strong>。</p>
<p> </p>
<p>使用私有继承，基类的公有成员和保护成员都将成为派生类的私有成员。</p>
<p>这意味着基类方法将不会成为派生类对象公有接口的一部分（公有继承，派生类可以使用基类的大部分方法），但可以在派生类的成员函数中使用它们。</p>
<p> </p>
<p> </p>
<p><strong>私有继承的特点：</strong></p>
<p>①继承方式类似公有继承，但使用private关键字替代public关键字；</p>
<p> </p>
<p>②没有显式的对象名；</p>
<p> </p>
<p>③需要使用其他办法替代 当使用类对象作为类数据成员时使用的方法。</p>
<p> </p>
<p>④基类被称为子类。</p>
<p> </p>
<p> </p>
<p>使用多个基类的继承，被称为 多重继承（MI），通常，MI，尤其是公有MI将导致一些问题，必须使用额外的语法规则来解决他们。</p>
<p> </p>
<p> </p>
<p><strong>私有继承的一些特殊之处：</strong></p>
<p> </p>
<p>①私有继承将提供无名称的子类对象成员，因此不能使用像name来描述对象，而应使用用于公有继承的技术。</p>
<p> </p>
<p>②访问基类的方法：使用私有继承时，只能在派生类中使用基类的方法，但有时候可能希望基类工具是公有的。那么就在公有方法的函数中，使用私有方法。例如double Student::average(int i) { return arr::average(i); }这样，通过作用域解析运算符来区分。</p>
<p> </p>
<p>③访问基类的对象：使用强制类型转换，</p>
<p>例如 (const string&amp;)*this，其中this是指向当前对象的指针，*this是当前对象，强制类型转换后获得子类string。</p>
<p>对于数组的访问，使用((const arr&amp;)*this)[i]，用括号括起来，强制类型转换后（成为一个valarray数组）然后添加运算符。</p>
<p> </p>
<p>④访问基类的友元函数：</p>
<p>访问类的子类时，使用强制类型转换，将类对象显式转换为基类来调用正确的函数（前提是子类有相应的类方法）</p>
<p> </p>
<p> </p>
<p>对普通has-a关系的进行修改，使用私有继承类的方法：</p>
<pre>#ifndef STU_
#define STU_
#include&lt;string&gt;
#include&lt;valarray&gt;

using namespace std;
class Student:private string,private valarray&lt;double&gt;
{
	typedef valarray&lt;double&gt; arr;	//将arr作为其别名
	ostream&amp; scores_out(ostream&amp; os)const;	//输出分数，我怀疑可以使用void作为返回值应该也可以。
public:
	Student() :string("No Student"), arr() {}	//默认构造函数，名字为No Student，分数无
	explicit Student(const string&amp; s) :string(s), arr() {}		//构造函数，参数为string类对象，赋值给name，关闭隐式转换
	explicit Student(int n) :string("No name"), arr(n) {}		//构造函数，初始化分数的数量（不是值），关闭隐式转换
	Student(const string&amp;s, int n) :string(s), arr(n) {}		//参数为name赋值，并声明有几个分数
	Student(const string&amp;s, const arr&amp;a) :string(s), arr(a) {}		//参数为name赋值，并将数组赋值给分数（调用的valarray的复制构造函数）
	Student(const string&amp;s, const double*pd, int n) :string(s), arr(pd, n) {}		//类似上面，分数有n个成员，并用pd数组初始化能初始化的那几个
	~Student() {}			//析构函数，不声明也可以
	double Average();		//返回平均分
	const string&amp; Name()const;		//返回姓名
	double &amp; operator[](int i);		//返回第n个分数，可被修改
	double operator[](int i)const;		//这个和上面有啥区别？不能被修改？
										//friend友元函数
	friend istream&amp; operator &gt;&gt; (istream&amp;is, Student&amp; Stu);	//输入，一个单词
	friend istream&amp; getline(istream&amp;is, Student&amp; stu);	//输入，但是一行
	friend ostream&amp; operator&lt;&lt;(ostream&amp;os, const Student&amp;stu);	//输出
};
#endif // !STU_

#include&lt;iostream&gt;
#include"stu.h"
using namespace std;

ostream&amp; Student::scores_out(ostream&amp; os)const
{
	int i = 0;
	int lim = arr::size();		//使用作用域解析运算符替代scores.
	if ( lim &gt; 0)
	{
		for (i = 0;i &lt; lim;i++)
		{
			os &lt;&lt; arr::operator[](i) &lt;&lt; " ";	//显式调用子类的方法，这里不能使用强制类型转换，因为是数组（
			if (i % 5 == 4)
				os &lt;&lt; endl;
		}
		if (i % 5 != 0)
			os &lt;&lt; endl;
	}
	else
		os &lt;&lt; "empty" &lt;&lt; endl;
	return os;
}

double Student::Average()	//返回平均分
{
	if (arr::size() &gt; 0)
	{
		return arr::sum() / arr::size();
	}
	else
		return 0;
}

const string&amp; Student::Name()const
{
	return (const string&amp;)*this;	//使用强制类型转换来替代
}
double &amp; Student::operator[](int i)	//返回分数
{
	return arr::operator[](i);	//使用了valarray的类方法
}
double Student::operator[](int i)const
{
	return arr::operator[](i);
}

istream&amp; operator&gt;&gt;(istream&amp; is, Student&amp;stu)//输入，一个单词
{
	is &gt;&gt; (string&amp;)stu;	//因为是输入，不能加const
	return is;
}

istream&amp; getline(istream&amp;is, Student&amp; stu)	//输入，但是一行
{
	getline(is, (string&amp;)stu);
	return is;
}
ostream&amp; operator&lt;&lt;(ostream&amp;os, const Student&amp;stu)	//输出
{
	os &lt;&lt; (const string&amp;)stu &lt;&lt; "'s scores: " &lt;&lt; endl;
	stu.scores_out(os);
	return os;
}
</pre>
<p><strong>使用包含还是私有继承：</strong></p>
<p>建立has-a关系，一般来说，使用包含，因为包含用起来更简单，也可以包含多个同类对象，例如string name; string firstname; string lastname; 而若使用继承，则只能包含一个子类对象。</p>
<p>但若要使用基类的保护对象，则使用继承，因为只有派生类能访问基类的保护成员，而包含是不能访问被包含对象的基类成员的（只能通过公有接口）。</p>
<p> </p>
<p> </p>
<p><strong>保护继承：</strong></p>
<p>保护继承的方式类似私有继承，使用关键字protected。</p>
<p>如：</p>
<p>class Student:protected std::string , protected std::valarray&lt;double&gt;</p>
<p>{..}</p>
<p> </p>
<p>使用保护继承时，基类的公有成员和保护成员，都将成为派生类的保护成员。</p>
<p> </p>
<p>和私有继承一样，基类的接口在派生类中也是可用的（通过基类对象访问基类的公有方法），</p>
<p> </p>
<p>但在继承层次之外的结构是不可用的（保护继承是因为成为保护成员，不能在类外访问，即流程为public--&gt;protected，而protected只能被基类和派生类使用）（私有继承则因为本身就视派生类为类外，派生类不能使用私有继承的基类方法，只能通过基类的公共接口调用，使用作用域解析运算符）。</p>
<p> </p>
<p>因此，二者都可以通过基类接口调用</p>
<p> </p>
<p>保护继承和私有继承的区别在于：</p>
<p>①在派生类派生出第三代时（即派生类的派生类），由于保护成员将被派生类继承，因此，保护继承的第三代将能使用第一代的基类接口（因为第一代的公共成员在第二代变为保护成员，而保护成员在派生类内，被视为公有成员）。</p>
<p> </p>
<p>②而私有继承的第三代则不能使用，因为第一代的公共方法在第二代内作为私有方法被继承，因此第二代只能通过第一代的公共接口来调用。</p>
<p>访问形式为：基类的作用域解析运算符来使用方法。但需要注意的是，此时基类已经成为私有成员。</p>
<p>而进入第三代后，由于派生类不能访问基类的私有成员。因此，第三代是不能访问身为第二代私有成员的第一代类对象的（无论第三代通过什么来继承）。</p>
<p> </p>
<p>附表：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAyMjExNzA3MjczNDI=.jpg"></p>
<p><strong>使用using重新定义访问权限：</strong></p>
<p>在保护继承或私有继承时，基类的公有成员将成为派生类的保护或者私有成员（因此，该方法是不能在类外使用的）。如果要使用基类的方法，那么</p>
<p> </p>
<p>方法一：定义一个该基类方法的派生类方法。</p>
<p>例如：</p>
<p>double Student::sum()const</p>
<p>{<br />
return std::valarray&lt;double&gt;::sum();</p>
<p>}</p>
<p>通过这种方法，Student类调用方法.sum()时，实际上相当于调用基类的sum()方法，即将其基类valarray对象求和。</p>
<p> </p>
<p> </p>
<p>方法二：在公有部分使用using声明。</p>
<p>例如：</p>
<p>class Student</p>
<p>{</p>
<p>...</p>
<p>public:</p>
<p>using std::valarray&lt;double&gt;::sum;</p>
<p>...</p>
<p>}</p>
<p>效果和方法一是相同的，即使得基类的sum()方法就像成为了派生类的公有方法一样。</p>
<p>注意：只需要函数名sum，不需要特征标，返回类型，和圆括号。</p>
<p> </p>
<p>那么对于重载函数的兼容性如何？可以使用所有重载函数？从文中看来是这样的。</p>
<p> </p>
<p>对于运算符重载，需要加上相应的重载运算符符号。例如：</p>
<p>using std::valarray&lt;double&gt;::operator[];</p>
<p>这将使const和非const版本都可用。</p>
<p> </p>
<p>需要注意的是：</p>
<p>using声明 只适合继承，不适合 包含。</p>
<p>也就是私有继承可用，但将类对象作为另一个类对象成员时（包含）是不可用的。</p>
<p> </p>
<p>还有一种老式方式，可用于在派生类中重新声明基类方法，即将方法名放在派生类的公有部分。</p>
<p>如：</p>
<p>class Student</p>
<p>{</p>
<p>...</p>
<p>public:</p>
<p>std::valarray&lt;double&gt;::sum;</p>
<p>...</p>
<p>}</p>
<p>和using声明很像，但按书上所说，这种方法即将被抛弃，应放弃使用这种方法，而改用using方法，除非编译器不支持using方法。</p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 20:40:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>（一四七）私有继承的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBKjWAM.html" rel="bookmark">关于C&plus;&plus;中公有继承、私有继承、保护继承的讨论</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.文章来由 简单明了的理由,老生常谈但是没真正解决的问题,想搞清楚这个问题. 二.冗长的定义 我们先来看看这些冗长的定义: 公有继承: 当类的继承方式为公有继承时,基类的公有成员和保护成员的访问属性在派生类中不变,而基类的私有成员不可直接访问.也就是说基类的公有成员和保护成员被继承到派生类中访问属性不变,仍作为派生类的公有成员和保护成员,派生类的其他成员可以直接访问它们.在类族之外只能通过派生类的对象访问从基类继承的公有成员. 私有继承: 当类的继承方式为私有继承时,基类中的公有成员和保护成员			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5A65Bp.html" rel="bookmark">C&plus;&plus;箴言：谨慎使用私有继承</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在&lt;C++箴言:确保公开继承模拟&quot;is-a&quot;&gt;一文中论述了 C++ 将 public inheritance(公有继承)视为一个 is-a 关系.当给定一个 hierarchy(继承体系),其中有一个 class Student 从一个 class Person 公有继承,当为一个函数调用的成功而有必要时,需要将 Students 隐式转型为 Persons,它通过向编译器展示来做到这一点.用 private inheritance(私有继承)代替 public inher			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEEAg9b.html" rel="bookmark">轨迹系列&mdash;&mdash;验证轨迹GPS坐标转换为本地坐标的四&sol;七参数是否准确的一种方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章版权由作者李晓晖和博客园共有,若转载请于明显处标明出处:http://www.cnblogs.com/naaoveGIS/ 1. 背景 目前对多个项目轨迹不准确的情况做了排查,发现导致轨迹偏移百分之七八十的原因反而是转换四参数不准确导致.所以,比起进行轨迹优化等,最根本需要解决的是四参数(通过三个及以上控制点对换算得出)不准确问题.那么如何判断四/七参数是否准确呢?针对这个问题我们给出一个通用方案. 2.原理说明 这里,我们从两个方面着手,一个是验证我们系统地图本身是否偏移,第二个是验证在地			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjLG9dp.html" rel="bookmark">Java Reflection&lpar;七&rpar;&colon;私有变量和私有方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址 作者: Jakob Jenkov 译者:叶文海(yewenhai@gamil.com) 内容索引访问私有变量访问私有方法 在通常的观点中从对象的外部访问私有变量以及方法是不允许的,但是Java反射机制可以做到这一点.使用这个功能并不困难,在进行单元测试时这个功能非常有效.本节会向你展示如何使用这个功能. 注意:这个功能只有在代码运行在单机Java应用(standalone Java application)中才会有效,就像你做单元测试或者一些常规的应用程序一样.如果你在Java App			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBGVlb.html" rel="bookmark">（一四二）继承和动态内存分配</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当基类.派生类用,或者不用动态内存时,共有四种情况: (注意,前提是基类的动态内存分配相关函数符合常规使用动态内存的要求)   情况一:基类 使用 动态内存分配.派生类新增数据成员 不使用 动态内存分配 假如基类使用动态内存分配(new),其必然设定①构造函数.②复制构造函数.③赋值运算符.④析构函数. 又知,派生类的构造函数(包括默认构造函数),需要调用基类的构造函数. 那么基类的数据成员若使new,则已经没问题. 派生类新增的数据成员,由于不使用new,因此可以按值传递.   ①对于派生类构			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2ZmGVb.html" rel="bookmark">JavaScript高级程序设计 阅读笔记（十四） js继承机制的实现&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				继承 继承是面向对象语言的必备特征,即一个类能够重用另一个类的方法和属性.在JavaScript中继承方式的实现方式主要有以下五种:对象冒充.call().apply().原型链.混合方式. 下面分别介绍. 对象冒充 原理:构造函数使用this关键字给所有属性和方法赋值.因为构造函数只是一个函数,所以可以使ClassA的构造函数成为ClassB的方法,然后调用它.ClassB就会收到ClassA的构造函数中定义的属性和方法. 示例: 复制代码 代码如下: function ClassA(sCol			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mv7OR5p.html" rel="bookmark">一口一口吃掉Hibernate（七）&mdash;&mdash;继承映射</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				       前几篇博文中讲到了常用的几种关联映射.其实Hibernate中还有一种&quot;省劲儿&quot;的映射,那就是--&quot;继承映射&quot;.        学了这么多的关系映射了,继承映射,从字面上也能了解到猜到几分.没错,继承映射就是为继承树而设置的一种映射方案.        继承映射的实现有三种策略: 单表继承.每棵类继承树使用一个表 类表继承.每个子类生成一个表. 具体表继承.每个类生成一个表.       我们还是用实例来说明一下,直接上图吧:        Pig和B			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoKLBb.html" rel="bookmark">java-JAVA子类不能继承父类私有方法是么</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 JAVA子类不能继承父类私有方法是么 父类都不能用他本身的私有方法,子类岂不是更不能用了,这一点是怎么证明的?举个例子 解决方案 父类本身的私有方法是可以被自己的其他方法调用的,但是这些私有方法子类是不能调用的,但是可能被间接调用. 例如下面的例子,父类的私有方法被一个公有方法调用了,那么子类继承这个公有方法后也就间接调用了父类的私有方法了.但是子类可直接访问的方法里却没有这个私有方法的. public class Parent { public void say(){ call();			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5GGnb.html" rel="bookmark">C&plus;&plus;：通过私有&lpar;private&rpar;继承复用类实现工厂函数详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通过接口类(interface class), 实现工厂函数, 可以复用(reuse)已有类, 重写实现接口. 如: 接口类: IPerson; 复用类: PersonInfo; 实现类: CPerson; 工厂函数: DatabaseID askUserForDatabaseID(); std::shared_ptr&lt;IPerson&gt; makePerson(DatabaseID personIndetifier); 可以通过私有继承复用类PersonInfo,公有继承接口类IPerson,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvKvap.html" rel="bookmark" class="title">音乐连播功能主要用到的 JS对WMP的操作</a>
					<div>
						WMP-网页中常见属性和方法&lt;object classid=&quot;CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6&quot; type=&quot;a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPNmvb.html" rel="bookmark" class="title">word2013中如何添加着重号</a>
					<div>
						  word2013中添加着重号的步骤如下: 步骤一:鼠标左键双击计算机桌面Word2013程序图标,将其打开运行.在打开的Word2013程序窗口,点击&quot;打开其他文档&quot;选项,然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmK63b.html" rel="bookmark" class="title">asp&period;net-程序流程图什么样子？跟业务流程图有什么区别？</a>
					<div>
						问题描述 程序流程图什么样子?跟业务流程图有什么区别? 在网上查了一下,好多没用的,还有很低级的程序流程图,什么if while循环过程的程序流程图,不是我要的那种.蒙圈- 解决方案 业务流程图是大流 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVEGKp.html" rel="bookmark" class="title">关于组合查询并排序的问题</a>
					<div>
						排序|问题|组合查询|排序|组合查询 有如下记录id    stype    s    mtype            m    rtype    r214    空白    108    教学效果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdkOmM.html" rel="bookmark" class="title">利用adodb&period;stream直接下载任何后缀的文件&lpar;防盗链&rpar;</a>
					<div>
						ado|stream|防盗链|下载 原作:possible_Y,载自时代课堂 在浏览器的地址栏里直接输入一个doc或xls或jpg的文件的url路径,那么该文件会直接显示在浏览器里.而在很多时候我们希 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5BEBz.html" rel="bookmark" class="title">如何显示一个表的字段信息（ACCESS）</a>
					<div>
						access|显示   &lt;%sub Col_show(tablename)%&gt;   &lt;table  border=&quot;1&quot; cellspacing=&quot;0& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKnmZz.html" rel="bookmark" class="title">谈谈如何利用好分类信息网的几点技巧</a>
					<div>
						随着分类信息网的崛起,相信做网络推广和SEO的人都爱上了它们,一来它们可以提供大量的外链支撑,二来还有不错的品牌推广效果.而分类信息网之所以也做的乐不思蜀,主要原因是网络推广人员给它们推广了品牌,带来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjky6M.html" rel="bookmark" class="title">SEO优化 网站关键词建设四大技巧</a>
					<div>
						技巧一:关键词凸显在网页的标题中(重要性 ★★★★★) 关键词在网页标题(title tag)中得凸显是大家公认的在整个SEO工程中最重要的工作,当然关键词的选择是重中之重,是所有工作的基础.普遍认为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5GEWb.html" rel="bookmark" class="title">解决每次打开office 2010都会出现正在配置的问题</a>
					<div>
						有时候我们安装好office2010后,每次打开word 或者 PPT或者其他office文档时候会提示&quot;安装程序正在准备必要的文件&quot;然后是&quot;正在配置Microsoft  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL6o5b.html" rel="bookmark" class="title">Groovy、Scala 和 Clojure 如何将行为融入到类中</a>
					<div>
						Java 语言的设计有目的地进行了一定的删减,以避免前代产品中已发现的一些问题.例如,Java 语言的 设计人员感觉 C++ 中的多重继承性带来了太多复杂性,所以它们选择不包含该特性.事实上,他们在该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNZqDb.html" rel="bookmark" class="title">Windows XP 技巧-应用篇</a>
					<div>
						为了能更好的应用Windows,下面笔者就来介绍几个搜索到的应用方面的小技巧. 1.关掉调试器Dr. Watson: Dr.Watson会在程序加载失败或崩溃时显示.运行drwtsn32,把 &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NyR0z.html" rel="bookmark" class="title">利用Servlet开发企业级三层Web应用（二）</a>
					<div>
						3.实现中间层 下面以BookServlet为例,说明如何实现中间层的Servlet. (1)初始化Servlet public class BookServlet extends HttpServl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91PkoM.html" rel="bookmark" class="title">Emit学习-实战篇-实现一个简单的AOP框架（二）</a>
					<div>
						已经9点了,就不废话了,直接开讲,今天就简单的介绍下框架中用到的一些接口和属性.昨天把我们关注的切面分成了三类,现在给出这3个接口的定义: 接口定义 /// &lt;summary&gt; /// 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP81wmp.html" rel="bookmark" class="title">Win8创建图片密码与Pin码</a>
					<div>
						  图片密码是一种帮助用户保护触摸Win8电脑的全新方法.用户可以选择图片并在图片上画出各种手势,以此来创建属于自己的独一无二的密码.接下来我们来看看设置图片密码的流程. 一.在屏幕右侧的Charm条 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJKRnp.html" rel="bookmark" class="title">如何安装Windows8系统中的telnet组件</a>
					<div>
						  1.系统桌面下同时按住键盘上 &quot;Windows&quot; 和 &quot;X&quot; 键打开系统菜单,选择&quot;控制面板&quot;.参见下图 2.在&quot;控制面板&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8yPvp.html" rel="bookmark" class="title">如何快速卸载电脑应用</a>
					<div>
						  1.点击你的菜单面板右边的&quot;控制面板&quot; 点击&quot;控制面板&quot;进入到下一个窗口找到&quot;程序和功能&quot; 点击这个功能后你就直接进入到应用的删除界面了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Y0DkM.html" rel="bookmark" class="title">JS实现横向拉伸动感伸缩菜单效果代码&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JS实现横向拉伸动感伸缩菜单效果代码.分享给大家供大家参考.具体如下: 这是一款JS实现的纵向拉伸变横向拉伸,动感伸缩菜单,紧身排列的CSS菜单,可用在博客等重要的位置部分作菜单,学习J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5N0Vqz.html" rel="bookmark" class="title">大型网站图片服务器架构的演进（转）</a>
					<div>
						  在主流的Web站点中,图片往往是不可或缺的页面元素,尤其在大型网站中,几乎都将面临&quot;海量图片资源&quot;的存储.访问等相关技术问题.在针对图片服务器的架构扩展中,也会历经很多曲折甚至 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvry91M.html" rel="bookmark" class="title">将国际商业外包引入中国进出口</a>
					<div>
						2007年,&quot;国际商业外包&quot;这个颇具神秘色彩的概念开始在中国对外贸易中频繁出现. 在规模超过2万名专业客商的第十一届海峡两岸机械电子商品交易会暨厦门对台进出口商品交易会(以下简称& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQykNp.html" rel="bookmark" class="title">云堆栈三大服务模式解析</a>
					<div>
						                    如果准备使用云计算或者要在自己的IT环境中部署云计算,首先要确定合适的服务模式.这就需要我们对每种服务模式含义和特点都有所了解,很清楚从中能够获得哪些有益东西. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRRrep.html" rel="bookmark" class="title">java代码执行js-java代码模拟浏览器，访问网页；使网页中的统计代码能执行。</a>
					<div>
						问题描述 java代码模拟浏览器,访问网页:使网页中的统计代码能执行. 我的操作步奏: 1.Eclipse里面写个简单的jsp页面,加入CNZZ统计脚本,启动服务器. 2.浏览器访问.浏览器中访问js ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pke70yb.html" rel="bookmark" class="title">MySQL内核月报 2014&period;11-TokuDB&CenterDot;　版本优化&CenterDot;　7&period;5&period;0</a>
					<div>
						TokuDB 7.5.0大版本已发布,是一个里程碑的版本,这里谈几点优化,以飨存储引擎爱好者们. a) shutdown加速 有用户反馈TokuDB在shutdown的时候,半个小时还没完事,非常不可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR6L5b.html" rel="bookmark" class="title">谷歌量子计算机新进展 明年或将面世</a>
					<div>
						北京时间9月2日,根据国外媒体的报道,谷歌团队距离完成全新的超强量子计算设备已经不远,或许这款设备将会在明年年底之前发布. 尽管目前谷歌方面并没有正式对量子计算设备的研发进度对外公布,但是根据不少该领 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Relaz.html" rel="bookmark" class="title">vs2010 方法提示快捷键</a>
					<div>
						问题描述 不是ctrl+j!vs2010写完了的方法必须要鼠标放到上面才能看方法说明,ctrl+j弹出来的显示太慢了,想要鼠标停留弹出的提示有没有像eclipse的alt+/那样的快捷键 解决方案 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j7KXp.html" rel="bookmark" class="title">MySQL server has gone away问题解决办法</a>
					<div>
						执行一个SQL,但SQL语句过大或者语句中含有BLOB或者longblob字段.比如,图片数据的处理.都容易引起MySQL server has gone away. 今天遇到类似的情景,MySQL只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJO00qb.html" rel="bookmark" class="title">调用发布 的wcf-ajax调用发布IIS的wcf服务  400</a>
					<div>
						问题描述 ajax调用发布IIS的wcf服务 400 创建WCF服务项目,用WCF应用程序作为宿主加载,发布IIS,ajax 用ip加方法名访问,一直出现错误,传说中好像跨域了,那位大神有demo,或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWNRlz.html" rel="bookmark" class="title">网络安全立法 各国面面观</a>
					<div>
						我国网络安全立法再一次迈出了实质性步伐!继今年6月第十二届全国人大常委会第十五次会议初审了&lt;中华人民共和国网络安全法(草案)&gt;后,7月6日,中国人大网将网络安全法(草案)全文公布,向社会公 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJeqk4p.html" rel="bookmark" class="title">近5年哪些专业毕业后收入高？信息安全物联网法语专业排前列</a>
					<div>
						今天,大部分考生将结束高考,进入等分和考虑意向学校和专业的阶段.在选择专业时,考生和家长除了考虑专业就业率,还会考虑毕业后收入.就业满意度等因素. 昨日发布的&quot;近5年就业率.月收入前十专业排 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAArNp.html" rel="bookmark" class="title">css3 选择器（二）</a>
					<div>
						接css3选择器(一) 八.结构性伪类选择器[:nth-child(n)] :nth-child(n)选择器用来匹配某个父元素的一个或多个特定的子元素,和jquery中一样. 其中&quot;n&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBdPkb.html" rel="bookmark" class="title">五种智慧城市运营模式 你都懂吗？</a>
					<div>
						智慧城市建设已经成为推动信息化发展的重要动力,而当前智慧城市的建设已经进入一个务实发展的新阶段,新型智慧城市的目标日益清晰,体制和流程的变革逐步深入,创新技术不断涌现.那么你知道智慧城市的运营模式有哪 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
